RepHeaderRemember = LibStub("AceAddon-3.0"):NewAddon("RepHeaderRemember", "AceHook-3.0")

local defaults = {
	profile = {
		HeaderCollapsed = {}
	},
}

local fRepPaneShown = false

-- Called when the addon is loaded
function RepHeaderRemember:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RepHeaderRememberDB", defaults)
end

-- Called when the addon is enabled
function RepHeaderRemember:OnEnable()
	RepHeaderRemember:Hook("ReputationFrame_OnShow", true)
	RepHeaderRemember:Hook("CollapseFactionHeader", true)
	RepHeaderRemember:Hook("ExpandFactionHeader", true)
end

-- Saves the name of a header that was collapsed
function RepHeaderRemember:CollapseFactionHeader(index, ...)
	name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
	if (isHeader) then 
		self.db.profile.HeaderCollapsed[name] = true
	end
	
	self.hooks["CollapseFactionHeader"](index, ...)
end

-- Saves the name of a header that was expanded
function RepHeaderRemember:ExpandFactionHeader(index, ...)
	name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
	if (isHeader) then 
		self.db.profile.HeaderCollapsed[name] = false
	end
	
	self.hooks["ExpandFactionHeader"](index, ...)
end

-- If Rep frame is being shown for first time, collapse headers.
function RepHeaderRemember:ReputationFrame_OnShow(...)
	if (not fRepPaneShown) then self:CollapseHeaders() end

	self.hooks["ReputationFrame_OnShow"](...)
end

-- Reads list of saved header names and collapses or expands them to match saved value.
function RepHeaderRemember:CollapseHeaders()
	for index=1, GetNumFactions(), 1 do
		name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed = GetFactionInfo(index)
		if isHeader and self.db.profile.HeaderCollapsed[name] ~= nil then
			if self.db.profile.HeaderCollapsed[name] and not isCollapsed then
				CollapseFactionHeader(index)
			elseif not self.db.profile.HeaderCollapsed[name] and isCollapsed then
				ExpandFactionHeader(index) 
			end
		end
	end
	
	fRepPaneShown = true
end

